import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { GoodsCoupon, GoodsCouponParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品优惠券表
 */
export async function pageGoodsCoupon(params: GoodsCouponParam) {
  const res = await request.get<ApiResult<PageResult<GoodsCoupon>>>(
    MODULES_API_URL + '/shop/goods-coupon/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品优惠券表列表
 */
export async function listGoodsCoupon(params?: GoodsCouponParam) {
  const res = await request.get<ApiResult<GoodsCoupon[]>>(
    MODULES_API_URL + '/shop/goods-coupon',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品优惠券表
 */
export async function addGoodsCoupon(data: GoodsCoupon) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-coupon',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品优惠券表
 */
export async function updateGoodsCoupon(data: GoodsCoupon) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-coupon',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品优惠券表
 */
export async function removeGoodsCoupon(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-coupon/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品优惠券表
 */
export async function removeBatchGoodsCoupon(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-coupon/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品优惠券表
 */
export async function getGoodsCoupon(id: number) {
  const res = await request.get<ApiResult<GoodsCoupon>>(
    MODULES_API_URL + '/shop/goods-coupon/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
